<p>
    Zur Speicherung von Daten werden in der Regel <span
        class="bold">Datenbanken</span> verwendet. Unternehmen und Organisationen wie Banken,
    Flugunternehmen oder Universitäten speichern ihre Daten in Datenbanken. Aber was sind die Vorzüge
    der Nutzung einer Datenbank? Schauen wir uns das an einem Beispiel an:
</p>
<h2>Ein Limo-Shop für Dresden</h2>
<div class="card ovk-story">
    <div class="card-body schon-gewusst-body">
        <p>
            <img style="max-width: 14em;" class="ovk-float-right"
                src="{{ data 'domain_root' }}/static/Informatik/Datenbanken/Webshop.svg" alt='Webshop'
                id="webshop" />
            Ein Freundeskreis hat eine Geschäftsidee und möchte Limonaden herstellen und diese
            verkaufen. Die rechtlichen Hürden sind genommen, jetzt bauen sie sich eine Webseite, auf der
            die Limonaden angeboten werden.
            <br />
            <img style="max-width: 14em;" class="ovk-float-left"
                src="{{ data 'domain_root' }}/static/Informatik/Datenbanken/Kontaktformular.svg"
                alt='Bestellformular' id="bestellformular" />
            Die Seite hat ein Bestellformular, welches die Kunden ausfüllen können. Mit einem Klick
            auf &bdquo;Absenden&ldquo; wird dem Team eine E-Mail mit den im Formular hinterlegten
            Informationen zugestellt. Der/die Kund:in erhält die
            Rechnung ebenfalls per E-Mail.<br />
        </p>
        <p>
            Das Team verwaltet die eingehenden Informationen in einer Datei,
            <img style="max-width: 28em;" class="ovk-float-right"
                src="{{ data 'domain_root' }}/static/Informatik/Datenbanken/Tabelle.png" alt='Tabelle'
                id="tabelle" />
            welche in einem Tabellenkalkulationsprogramm bearbeitet werden kann. Die
            Datei enthält eine Tabelle mit Spalten Name, Vorname, Email-Adresse,
            Adresse und die Information, welche Limonaden bestellt wurden.
        </p>
        <p>
            Schon bald schafft dieser Ansatz eine ganze Reihe Probleme:

        <div class="card" style="background-color: inherit;">
            <div class="card-header" style="background-color: inherit;">
                <button class="btn ovk-expand" data-bs-toggle="collapse" data-bs-target="#collapseOne"
                    aria-expanded="true" aria-controls="collapseOne">
                    Gemeinsamer Zugriff
                </button>
            </div>
            <div id="collapseOne" class="card-body collapse show" style="background-color: #e2f3e6;">
                <p>
                    Der gemeinsame Zugriff auf die Datei gestaltet sich schwierig. Das gleichzeitige
                        Bearbeiten der Tabelle ist nicht möglich,
                        auch wenn sie in einer Cloud-Lösung und versioniert abgespeichert liegt. Änderungen
                        Einzelner werden überschrieben und gehen verloren.
                </p>
            </div>
        </div>
        <div class="card" style="background-color: inherit;">
            <div class="card-header" style="background-color: inherit;">
                <button class="btn ovk-expand" data-bs-toggle="collapse" data-bs-target="#collapseTwo"
                    aria-expanded="true" aria-controls="collapseTwo">
                    Lokale Kopien und Redundanz
                </button>
            </div>
            <div id="collapseTwo" class="card-body collapse" style="background-color: #e2f3e6;">
                <p>
                    Es entstehen lokale Kopien der Datei, die Daten sind also mehrfach (redundant)
                    gespeichert. Änderungen der Daten in den Kopien werden nicht
                    in die gemeinsam genutzte Version übertragen. Das resultiert in inkonsistenten, sich
                    widersprechende Daten.
                </p>
            </div>
        </div>
        <div class="card" style="background-color: inherit;">
            <div class="card-header" style="background-color: inherit;">
                <button class="btn ovk-expand" data-bs-toggle="collapse" data-bs-target="#collapseThree"
                    aria-expanded="true" aria-controls="collapseThree">
                    Rechtschreibfehler
                </button>
            </div>
            <div id="collapseThree" class="card-body collapse" style="background-color: #e2f3e6;">
                <p>
                    <img style="max-width: 9em;" class="ovk-float-right"
                            src="{{ data 'domain_root' }}/static/Informatik/Datenbanken/Rechnung.svg"
                            alt='Rechnung' id="rechnung" />
                    Es tauchen immer einmal Rechtschreibfehler in den Namen auf. Es ist nicht möglich,
                    für jeden Kunden eine ordnungsgemäße Rechnung zu erstellen. Welcher Name soll auf der
                    Rechnung erscheinen, wenn die Daten in der Tabelle nicht konsistent sind?
                </p>
                <p>Das Team entscheidet sich dafür, die Tabellendatei nicht mehr weiter zu verwenden und die
                    Webseite stattdessen an eine Datenbank anzubinden.
                </p>
            </div>
        </div>
    </div>
</div>
<br />
<p>
{{> theorie }}
Die Vorteile der Nutzung einer Datenbank sind:
<ul class="ovk-bullet-list">
    <li>Redundanzvermeidung und Widerspruchsfreiheit</li>
    <li>Mehrbenutzerbetrieb: Mehrere Benutzer:innen können gleichzeitig auf dem Datenbestand
        arbeiten, ohne dass ihre Änderungen versehentlich überschrieben werden.
    </li>
</ul>
</p>
<p>
    Datenbanken dienen der Speicherung und der Bereitstellung von Daten. Daten selbst repräsentieren
    Fakten. Um basierend auf diesen Fakten Informationen zu erhalten, müssen die Daten miteinander
    verknüpft werden.
</p>
